/*
 * Ejercicio4.java
 *
 * Creado el 26 de diciembre de 2005, 23:38
 */


package computacion.practica3;
import auxiliar.*;

/**
 * La funcin 
 *      f(lambda) = p0 e^lambda + ne(e^lambda-1)/lambda
 * es estrictamente creciente en (0,infinito) porque 
 *      (e^lambda-1)/lambda = 1 + lambda/2! + lambda^2/3! + lambda^3/4! + ...
 * es estrictamente creciente en (0,infinito). Adems, f tiende a infinito 
 * cuando lambda tiende a infinito, y puede extenderse por continuidad a cero 
 * con 
 *      f(0) = p0 + ne.
 * Esto significa que si p1 > p0 + ne entonces existe un nico valor positivo
 * de lambda tal que f(lambda) = p1. As ocurre en las condiciones del 
 * ejercicio:
 *      p0 = 1000000,
 *      ne =  435000,
 *      p1 = 1564000.
 * Ntese por ltimo que la funcin (e^lambda-1)/lambda es positiva y menor 
 * que 1 si lambda es negativo (en el caso -1 < lambda < 0 esto se sigue del
 * desarrollo en serie, que proporciona una serie alternada cuyos trminos 
 * decrecen a 0), con lo que no existe ningun valor negativo de lambda tal
 * que f(lambda) = p1.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio4 {
    
    public static void main(String[] args) {
        FuncionEj4 p = new FuncionEj4(1000000, 1564000, 435000);
        double p2;
        double cero;
        
        try {
            System.out.println();
            System.out.println("Mtodo de Newton para p empezando en 1:");
            cero = MetodosIterativos.newton(p, 1, 1E-11, 100);
            p2 = p.p0 * Math.exp(cero * 2) + p.ne
                    * (Math.exp(cero * 2) - 1) / cero;
            System.out.println();
            System.out.println("Poblacin tras dos aos: " + p2);       
        } catch (MetodosIterativos.ErrorMetodosIterativos noconverge) {
        }
        
    }
    
}
