/*
 * ConjuntoDeJulia.java
 *
 * Creado el 2 de abril de 2007, 12:40
 */


package ecuacionesPolinomicas.practica9;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import auxiliar.*;
import ORG.netlib.math.complex.Complex;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class ConjuntoDeJulia {
    
    public static void main(String args[]) {
           
        PanelDibujoSimplificado pd = new PanelDibujoSimplificado(
                "Conjunto de Julia para p(z) = z^3 - 1");
        
        double x;
        double y;   
        int indice = 0;
        String[] colores = {"rojo", "azul", "amarillo"};
        Complex zini;
        Complex zfin;
        Complex uno = new Complex(1);
        Complex raiz1 = new Complex(- 0.5, Math.sqrt(3) / 2);
        Complex raiz2 = new Complex(- 0.5, - Math.sqrt(3) / 2);
        double[] coef = {- 1, 0, 0, 1};
        Polinomio p = new Polinomio(coef);
                
        pd.addEjesCoordenados(true, - 1, 1, - 0.8, 0.8);
        pd.repaint();
        
        for (int i = 0; i < 800; i++) {
            x = - 1 + i / 400.;
            for (int j = 0; j < 640; j++) {                
                y = - 0.8 + j / 400.;   
                zini = new Complex(x, y);
                try {
                    zfin = p.newton(zini, 0.001, 100);        
                    if (zfin.sub(uno).abs() < 0.2) {
                        indice = 0;
                    } 
                    else if (zfin.sub(raiz1).abs() < 0.2) {
                        indice = 1;
                    } 
                    else if (zfin.sub(raiz2).abs() < 0.2) {
                        indice = 2;
                    }
                    pd.addCurva(colores[indice], x, y);               
                } catch(Polinomio.ErrorPolinomios err) {
                }               
            }             
        }
        pd.repaint();
        
        
        pd.addWindowListener(
                new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        }
        );
        
    } // acaba el metodo main de la aplicacin PuntosAleatorios       
    
} // acaba la aplicacin PuntosAleatorios


