/*
 * Ejercicio4.java
 *
 * Creado el 7 de febrero de 2006, 16:35
 */


package ecuacionesPolinomicas.practica9;
import ORG.netlib.math.complex.Complex;
import auxiliar.*;

/**
 * En este ejercicio calculamos las races n-4, n-3 y n-2 del
 * polinomio de Wilkinson Wn(x)= (x-1)(x-2)...(x-n) para n = 5, 10, 15, 20.
 * 
 * Ntese que la evaluacin de las races del polinomio de Wilkinson 
 * produce errores cuando el grado del polinomio va aumentando. Ello 
 * es debido al error de redondeo que se produce al computar sus 
 * coeficientes.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio4 {
    
    public static void main(String[] args) {
        Polinomio p = new Polinomio();      
        int nsol = 0;
        
        for (int n = 5; n <= 20; n = n + 5) {
            try {
                System.out.println();
                System.out.println("Polinomio de Wilkinson de grado " + n + ":");
                p = wilkinson(n);
                System.out.println(p);
                
                System.out.println("Aproximacin de las soluciones"
                        + " s_" + "{" + (n - 4) + "} = " + (n - 4) + ","
                        + " s_" + "{" + (n - 3) + "} = " + (n - 3) + " y"
                        + " s_" + "{" + (n - 2) + "} = " + (n - 2)
                        + " por el mtodo de Newton tomando como" 
                        + "\ncondiciones iniciales respectivas "
                        + (n - 4.3) + ", " + (n - 3.3) + " y " + (n - 2.3));
                System.out.println("s_" + "{" + (n - 4) + "} = "
                        + p.newton(n - 4.3, 0.5E-6, 100));
                System.out.println("s_" + "{" + (n - 3) + "} = "
                        + p.newton(n - 3.3, 0.5E-6, 100));
                System.out.println("s_" + "{" + (n - 2) + "} = "
                        + p.newton(n - 2.3, 0.5E-6, 100));
            } catch(Polinomio.ErrorPolinomios err) {
            }
            
            try {
                System.out.println("Aproximacin de las soluciones"
                        + " s_" + "{" + (n - 4) + "} = " + (n - 4) + ","
                        + " s_" + "{" + (n - 3) + "} = " + (n - 3) + " y"
                        + " s_" + "{" + (n - 2) + "} = " + (n - 2)
                        + " por el mtodo de Laguerre tomando como" 
                        + "\ncondiciones iniciales respectivas "
                        + (n - 4.3) + ", " + (n - 3.3) + " y " + (n - 2.3));
                System.out.println("s_" + "{" + (n - 4) + "} = "
                        + p.laguerre(n - 4.3, 0.5E-6, 100));
                System.out.println("s_" + "{" + (n - 3) + "} = "
                        + p.laguerre(n - 3.3, 0.5E-6, 100));
                System.out.println("s_" + "{" + (n - 2) + "} = "
                        + p.laguerre(n - 2.3, 0.5E-6, 100));    
            } catch(Polinomio.ErrorPolinomios err) {
            }
        }
        
    }
    
    /**
     * Mtodo recursivo para calcular el polinomio de Wilkinson
     *          Wn(x)= (x-1)(x-2)...(x-n)
     */
    public static Polinomio wilkinson(int n)  {
        double[] coefmon = {- n, 1};
        Polinomio mon = new Polinomio(coefmon);
        double[] coefuno = {1};
        Polinomio uno = new Polinomio(coefuno);
        
        if (n == 0) {
            return uno;
        } else {
            return wilkinson(n - 1).producto(mon);
        }
    }
    
}
