/*
 * Ejercicio6.java
 *
 * Creado el 19 de febrero de 2006, 19:29
 */


package ecuacionesPolinomicas.practica9;
import ORG.netlib.math.complex.Complex;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio6 {
    
    public static void main(String[] args) {
        int n = 9;
        double[] a = new double[n + 1];
        Complex[] aux = {new Complex(0), new Complex(1)};
        int DNI = 26578156;
        Polinomio p = new Polinomio();
        Polinomio d = new Polinomio();        
        int nraizReal = 0;
        double[] raizReal = {0};
        int nraizComplex = 0;
        Complex[] raizComplex = {new Complex(0)};  
        double[][] intervalosSturm;          
        
        for (int k = 0; k <= n; k++) {
            a[k] = Math.pow(- 1, DNI / (k + 1)) * (DNI * (k + 1) % Math.PI);
        }
        p = new Polinomio(a);
        System.out.println("Polinomio p = " + p);
        
        try {            
            d = p;         
            System.out.println();
            System.out.println("Bsqueda de races reales para p");
            intervalosSturm = p.bisecSturm(0.1);
            nraizReal = intervalosSturm.length;
            raizReal = new double[nraizReal];
            for(int k = 0; k < nraizReal; k++) {
                System.out.println("Intervalo " + (k + 1) + ": ["
                        + intervalosSturm[k][0] + ", "
                        + intervalosSturm[k][1] + "]");
                raizReal[k] = intervalosSturm[k][0] + 0.5 *
                        (intervalosSturm[k][1] - intervalosSturm[k][0]);
                raizReal[k] = p.newton(raizReal[k], 0.5E-14, 100);
                System.out.println("Raz real " + (k + 1) 
                        + ": x_" + (k + 1) + " = " + raizReal[k]);
                System.out.println("Evaluacin de x_" + (k + 1) 
                        + ": p(x_" + (k + 1) + ") = " 
                        + p.eval(raizReal[k]));
                d = d.deflacion(raizReal[k]);
                System.out.println("Deflacin " + (k + 1) + ": " + d);       
            }
        } catch(Polinomio.ErrorPolinomios err) {
        }
        
        try {
            System.out.println("Comprobacin de que el polinomio " 
                        + "deflacionado no tiene races mltiples:");
            intervalosSturm = d.bisecSturm(0.1);
        } catch(Polinomio.ErrorPolinomios err) {
        }
         
        try {
            System.out.println();
            System.out.println("Bsqueda de races complejas para p");
            nraizComplex = n - nraizReal;
            raizComplex = new Complex[nraizComplex];
            for(int k = 0; k < nraizComplex / 2; k++) {                      
                raizComplex[2 * k] = 
                        d.laguerre(new Complex(), 0.5E-14, 100);
                System.out.println("Raz compleja " + (2 * k + 1) 
                        + ": z_" + (2 * k + 1) + " = " 
                        + raizComplex[2 * k]);
                System.out.println("Evaluacin de z_" + (2 * k + 1) 
                        + ": p(z_" + (2 * k + 1) + ") = " 
                        + p.eval(raizComplex[2 * k]));
                d = d.deflacion(raizComplex[2 * k]);                
                System.out.println("Deflacin " + (nraizReal + 2 * k + 1) 
                        + ": " + d);
                raizComplex[2 * k + 1] = raizComplex[2 * k].conj();
                System.out.println("Raz compleja " + (2 * k + 2) 
                        + ": z_" + (2 * k + 2) + " = " 
                        + raizComplex[2 * k + 1]);
                System.out.println("Evaluacin de z_" + (2 * k + 2) 
                        + ": p(z_" + (2 * k + 2) + ") = " 
                        + p.eval(raizComplex[2 * k + 1]));
                d = d.deflacion(raizComplex[2 * k + 1]);
                System.out.println("Deflacin " + (nraizReal + 2 * k + 2) 
                        + ": " + d);
            }
        } catch(Polinomio.ErrorPolinomios err) {
        }
        
        for (int k = 0; k < nraizReal; k++) {
            aux[0] = new Complex(- raizReal[k]);
            d = d.producto(new Polinomio(aux));            
        }
        for (int k = 0; k < nraizComplex; k++) {
            aux[0] = raizComplex[k].neg();
            d = d.producto(new Polinomio(aux));             
        }
        System.out.println();
        System.out.println("Comprobamos la bondad de las aproximaciones" 
                + " reconstruyendo el polinomio");
        System.out.println("Polinomio de partida: " + p);
        System.out.println("Polinomio reconstruido: " + d);
        System.out.println("Polinomio diferencia: " + p.resta(d));
    }
    
}
